-- NAV TECHDAYS - Alain Krikilion

-- by Jeremy Egbert
-- http://www.sqlservercentral.com/scripts/COMPRESS/69005/

WITH  TabInd ( TableName, IndexName, [type] )
        AS ( SELECT '[' + s.name + '].' + '[' + o.name + ']' AS 'tablename' ,
                    '[' + si.name + ']' AS 'indexname' ,
                    si.type
             FROM   sys.indexes si
                    INNER JOIN sys.objects o ON o.object_id = si.object_id
                    INNER JOIN sys.schemas s ON s.schema_id = o.schema_id
             WHERE  ( s.name <> 'sys' )
                    AND ( si.type IN ( 1, 2 ) ) -- clustered + nonclustered
           )
  SELECT  'RAISERROR(''INDEX ' + ti.TableName + ',' + ti.[IndexName]
          + ''',0,0) WITH NOWAIT; BEGIN TRANSACTION ALTER INDEX ' + ti.IndexName + ' ON '
          + ti.TableName + ' REBUILD WITH (DATA_COMPRESSION=PAGE); COMMIT; ' AS 'TSQL'
  FROM    TabInd ti
  ORDER BY TableName ,
          [type] ,
          IndexName
