-- NAV TECHDAYS - Alain Krikilion

DECLARE @databases AS VARCHAR(MAX) = '';

SELECT @databases = @databases + ',' + name
FROM sys.databases
WHERE user_access = 0 -- MULTI_USER
  AND is_read_only = 0 -- NO
  AND [state] = 0 -- ONLINE
  AND is_in_standby = 0 -- NO
  AND recovery_model = 3 -- SIMPLE
  AND database_id >= 7 -- exclude system DB's
ORDER by name;

SET @databases = SUBSTRING(@databases,2,99999999);

EXEC master.dbo.dba_indexDefrag_sp 
    @minFragmentation       = 10.0  
  , @rebuildThreshold       = 10.0  
  , @executeSQL             = 1
  , @timeLimit              = 5
  , @database               = @databases
  , @forceRescan            = 0
  , @sortInTempDB           = 0
  , @printCommands          = 1
  , @printFragmentation     = 1
  , @defragDelay            = '00:00:01'
  , @debugMode              = 0
  , @Compression = 'PAGE';
